// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	hivev1 "github.com/openshift/hive/apis/hive/v1"
	versioned "github.com/openshift/hive/pkg/client/clientset/versioned"
	internalinterfaces "github.com/openshift/hive/pkg/client/informers/externalversions/internalinterfaces"
	v1 "github.com/openshift/hive/pkg/client/listers/hive/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// SelectorSyncSetInformer provides access to a shared informer and lister for
// SelectorSyncSets.
type SelectorSyncSetInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.SelectorSyncSetLister
}

type selectorSyncSetInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewSelectorSyncSetInformer constructs a new informer for SelectorSyncSet type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewSelectorSyncSetInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredSelectorSyncSetInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredSelectorSyncSetInformer constructs a new informer for SelectorSyncSet type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredSelectorSyncSetInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.HiveV1().SelectorSyncSets().List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.HiveV1().SelectorSyncSets().Watch(context.TODO(), options)
			},
		},
		&hivev1.SelectorSyncSet{},
		resyncPeriod,
		indexers,
	)
}

func (f *selectorSyncSetInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredSelectorSyncSetInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *selectorSyncSetInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&hivev1.SelectorSyncSet{}, f.defaultInformer)
}

func (f *selectorSyncSetInformer) Lister() v1.SelectorSyncSetLister {
	return v1.NewSelectorSyncSetLister(f.Informer().GetIndexer())
}
